/*
 * SPIMaster.c
 *
 * Created: 22.05.2023 14:36:51
 *  Author: asus
 */ 


#include "SPIMaster.h"
#include <avr/io.h>
#include <util/delay.h>

void SPI_MasterInit(void)
{
	DDR_SPI = (1 << DD_MOSI) | (1 << DD_SCK) | (1 << DD_SS);
	DDRB |= (1<<DDB2);
	SPCR = (1 << SPE) | (1 << MSTR) | (1 << SPR1);
	// SPCR = (1 << SPE) | (1 << MSTR) ;
}

void SPI_MasterTransmit(char *data, int length)
{
	PORTB &= ~(1<<2);

	for(int i = 0; i < length; i++) {
		SPDR = data[i]; //   
		while (!(SPSR & (1 << SPIF))); // ,   
	}

	PORTB |= (1<<2);
}

char CRC8(char *data, int length) {
	char crc = 0x00;
	char poly = 0x07; //   CRC8

	for (int i = 0; i < length; i++) {
		crc ^= data[i]; // XOR    crc

		for (int j = 0; j < length; j++) {
			if (crc & 0x80) { //    crc  1
				crc = (crc << 1) ^ poly; //  crc  1    XOR  
				} else {
				crc <<= 1; //     1  
			}
		}
	}

	return crc;
}

char crc8(char *data, int len) {
	char crc = 0x00;
	while (len--) {
		crc ^= *data++;
		for (int i = 0; i < 8; i++) {
			if (crc & 0x80) {
				crc = (crc << 1) ^ 0x07;
				} else {
				crc <<= 1;
			}
		}
	}
	return crc;
}
